<?xml version="1.0"?>

<f:view xmlns="http://www.w3.org/1999/xhtml"
	xmlns:f="http://xmlns.jcp.org/jsf/core"
	xmlns:h="http://xmlns.jcp.org/jsf/html"
	xmlns:p="http://primefaces.org/ui"
	xmlns:pe="http://primefaces.org/ui/extensions"
	xmlns:ct="http://www.chartistjsf.org/charts"
	xmlns:ui="http://java.sun.com/jsf/facelets"
	xmlns:jsf="http://xmlns.jcp.org/jsf"
	xmlns:pass="http://xmlns.jcp.org/jsf/passthrough"
	xmlns:c="http://java.sun.com/jsp/jstl/core">
	<h:head>
		<h:outputStylesheet library="css" name="main.css" />
		<h:outputStylesheet library="css" name="w3.css" />
	</h:head>
	<f:metadata>
		<f:event type="preRenderView" listener="#{ideasBean.onPageLoad}" />
	</f:metadata>
	<h:body>
		<div id="idea-overview-grid">
			<h:form id="ideaoverviewform">
				<ui:repeat value="#{ideasBean.getIdeas()}" var="entry">
					<div class="w3-half w3-container w3-padding-small">
						<div class="w3-card-4">
							<img src="#{entry.titleImgRef}"
								style="width: 100%; height: 280px;" />
							<div class="w3-container w3-teal w3-padding">
								<H4>#{entry.title}</H4>
							</div>
							<div class="w3-container w3-margin-top" style="height: 40px;">
								<p>#{entry.shortdescription}</p>
							</div>
							<footer class="w3-container w3-teal">
								<div class="w3-bar">
									<div class="w3-bar">
										<a
											class="w3-bar-item w3-button w3-padding-small w3-border-left w3-border-right"
											style="float: right;" href="#{entry.getPageUrl()}">Enter</a>

										<ui:fragment
											rendered="#{ideasBean.isAdmin()}">
											<button
												class="w3-bar-item w3-button w3-padding-small w3-border-left w3-border-right"
												style="float: left;"
												jsf:action="#{ideasBean.deleteOnClick(entry.getIdeasId())}"
												jsf:process="@form">Delete</button>
										</ui:fragment>
									</div>
								</div>
							</footer>
						</div>
					</div>
				</ui:repeat>
			</h:form>
		</div>

		<!-- Options -->
		<div class="w3-bar w3-light-grey w3-padding-small">
			<button
				class="w3-button w3-large w3-circle w3-xlarge w3-ripple w3-blue"
				style="float: right;"
				onclick="document.getElementById('ideaInputModal').style.display='block'; setTimeout(function() {mymap.invalidateSize(); }, 100);">+</button>
		</div>

		<!-- Input Modal -->
		<div id="ideaInputModal" class="w3-modal">
			<h:form id="ideaInputModalForm" enctype="multipart/form-data">
				<h:inputHidden id="lat" value="#{ideaInputBean.lat}" />
				<h:inputHidden id="lng" value="#{ideaInputBean.lng}" />
				<div class="w3-modal-content w3-animate-opacity">
					<header class="w3-container w3-blue">
						<h2>New Idea</h2>
					</header>
					<div class="w3-container w3-padding-small">
						<p style="padding-bottom: 20px">
							<p:inputText class="w3-input w3-animate-input" type="text"
								style="width:40%" value="#{ideaInputBean.title}"
								placeholder="Enter the title of your idea here." />
						</p>

						<p style="padding-bottom: 15px">
							<p:inputText class="w3-input w3-animate-input" type="text"
								style="width:40%" value="#{ideaInputBean.shortDescription}"
								placeholder="Enter a short description here." />
						</p>

						<p:inputTextarea   rows="10" cols="60"
							value="#{ideaInputBean.description}"
							pass:placeholder="Describe your idea here." />

					<p> Click on the map to connect your idea to the chosen coordinates: </p>
					<!-- LEAFLET JAVASCRIPT -->
					<script>
					    define._amd = define.amd;
					    define.amd = false;
					</script>
						<link rel="stylesheet" href="https://unpkg.com/leaflet@1.2.0/dist/leaflet.css" />
						<script src="https://unpkg.com/leaflet@1.2.0/dist/leaflet.js"></script>
					<script>
					    define.amd = define._amd;
					</script>
					 <div id="mapid"></div>
						 <script>
							 var mymap = L.map('mapid').setView([48.174918, 11.596160], 13);
								L.tileLayer('http://{s}.tile.openstreetmap.org/{z}/{x}/{y}.png', {
								    maxZoom: 18,
								    id: 'mapbox.streets',
								    accessToken: 'your.mapbox.access.token'
								}).addTo(mymap);

								mymap.on('click', addMarker);

									var marker;
									function addMarker(e) {
										if(marker != null){
											mymap.removeLayer(marker);
										}
									        marker = new L.Marker(e.latlng, {draggable:false});
									        mymap.addLayer(marker);
									        document.getElementById("_JSFIdeaBoard_WAR_JSFIdeaBoard_:ideaInputModalForm:lat").value = e.latlng.lat;
									        document.getElementById("_JSFIdeaBoard_WAR_JSFIdeaBoard_:ideaInputModalForm:lng").value = e.latlng.lng;
									};
						 </script>
					 <!-- LEAFLET JAVASCRIPT END -->

						<h:panelGrid columns="3" style="margin-bottom:10px"
							cellpadding="5">
							<h:outputText value="Publish immediately"
								style="font: 15px Verdana" />
							<p:spacer width="5" />
							<p:selectBooleanCheckbox value="#{ideaInputBean.publish}"
								style="padding-top:10px" />
						</h:panelGrid>
					</div>
					<div class="w3-left-align w3-padding-small">
						<p>Select a title picture for your project</p>
					</div>
					<p:fileUpload id="fileUpload"
						fileUploadListener="#{ideaInputBean.upload}" mode="advanced"
						dragDropSupport="true" sizeLimit="200000"
						allowTypes="/(\.|\/)(gif|jpe?g|png)$/" fileLimit="1" />
					<footer class="w3-container w3-grey">
						<div class="w3-bar">
							<p:commandButton value="Submit" id="submitBtnProject"
								onclick="document.getElementById('ideaInputModal').style.display='none'"
								actionListener="#{ideaInputBean.createNewIdea}"
								styleClass="ui-priority-primary" style="float:right;">
							</p:commandButton>

							<p:button value="Cancel" id="cancelBtnProject"
								onclick="document.getElementById('ideaInputModal').style.display='none'">
							</p:button>
						</div>
					</footer>

				</div>
			</h:form>
		</div>
	</h:body>
</f:view>